// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 26 setiembre 2011
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// RBDJ RecipienteBasureroDeJulio
// El archivo dibuja un basurero sencillo a base
// de fractales
// Los fractales fueron tomados
// de la biblioteca scene/objects de PovRay3.6.
// Siendo entidades matematicas para demostracion, 
// asumo que no habra problema...
// No indican autor.
// #macro RBDJ_Basurero( Semilla )       
//      Semilla                 : parametro de aleatoriedad
//              la idea es misma semilla, mismo basurero.
// Las dimensiones del basurero son :
// Altura               : 715*L
// RadioBasurero        : 200*L
// En posicion basal descansa en el origen del plano XZ,
// orientado hacia y+.
//
// Otras macros que podrian ser de utilidad.
// #macro RBDJ_ObtenerUbicacion ( NumeroElegido, Clave )
//      NumeroElegido           : Variable de salida
//              da un numero secuencial para accesar un objeto basura
//              Posicion en el arreglo de objetos
//      Clave                   : Valor clave de identificacion
//              de basura. Los valores de entrada en la version
//              actual son RBDJ_A1..RBDJ_A10  
//              Valor del campo RBDJ_IndiceIdentificador
//              en el arreglo de objetos
//              
// #macro RBDJ_CirculoBasura
//        ( Semilla, SelectorMacro, Centro, Radio, Delta, 
//                PuntoCustom, PuntoS )
//      Semilla                 : parametros de aleatoriedad.
//      SelectorMacro           : valor para elegir la macro a utilizar
//              RBDJ_SuperficieCustom (definida por el usuario)
//              RBDJ_SuperficiePlana  (plano de altura 0) 
//              RBDJ_SuperficieRBDJ1  (curva default)
//      Centro                  : Centro como Vector3D del circulo
//              de basuras.  Al final de la macro se aplica
//              translate Centro
//      Radio                   : Radio del circulo de basura
//      Delta                   : Separacion media entre basura y basura
//      PuntoCustom             : Parametro libre a pasar a la
//              macro definida por usuario si se necesita.
//      PuntoS                  : Maxima distancia aleatoria
//              para errar la posicion de la basura.
//
// #macro RBDJ_RectanguloBasura
//      ( Semilla, SelectorMacro, XMin, XMax, DeltaX, 
//              YMin, YMax, DeltaY, PuntoCustom, PuntoS ) 
//      Semilla                 : parametros de aleatoriedad.
//      SelectorMacro           : valor para elegir la macro a utilizar
//              RBDJ_SuperficieCustom (definida por el usuario)
//              RBDJ_SuperficiePlana  (plano de altura 0) 
//              RBDJ_SuperficieRBDJ1  (curva default)   
//      XMin                    : Posicion X minima del rectangulo.
//      XMax                    : Posicion X maxima del rectangulo.
//      DeltaX                  : Separacion X de basura y basura.
//      YMin                    : Posicion Y minima del rectangulo.
//      YMax                    : Posicion Y maxima del rectangulo.
//      DeltaY                  : Separacion Y de basura y basura. 
//      PuntoCustom             : Parametro libre a pasar a la
//              macro definida por usuario si se necesita.
//      PuntoS                  : Maxima distancia aleatoria
//              para errar la posicion de la basura.
// El usuario define RBDJ_MacroCustom externamente, similar a...
// #macro RBDJ_MacroCustom
//                 ( AlturaSuperficie, BanderaPertenece, XX, YY, VectorA )
//   #local AlturaSuperficie       = 0.0;
//   #local BanderaPertenece       = true;
// #end
//              AlturaSuperficie        : altura del punto de basura.
//              BanderaPertenece        : si false no hay basura, si
//                      true si se dibuja
//              XX                      : valor X de entrada
//              YY                      : valor Y de entrada
//              VectorA                 : parametro libre de usuario. 
//                      Se refiere a PuntoCustom en otras macros.
// El usuario puede crear o desactivar sus propias basuras,
// Por ejemplo asumamos que tiene el objeto BasuraPersonal, con material
// MaterialPersonal, puede agregarla a la lista de basuras con
// el siguiente proceso
// A. declare su BasuraPersonal y MaterialPersonal, este 
//      ultimo como material
// B. asigne BasuraPersonal como nuevo elemento del
//      arreglo de objetos RBDJ_ArregloArticulos
//      el nuevo elemento tiene indice RBDJ_TotalArticulos
// C. asigne MaterialPersonal como nuevo material del
//      arreglo de materiales RBDJ_ArregloMaterial
//      el nuevo elemento tiene indice RBDJ_TotalMaterial
// D. actualice todos los campos de RBDJ_DescriptorArticulos
//      con el indice RBDJ_TotalArticulos
//      Es importante declarar todos los campos
//      RBDJ_IndiceIdentificador        : puede obtenerse
//              para un objeto conocido con la macro
//              RBDJ_ObtenerUbicacion 
//      RBDJ_IndiceActivo               : con off el objeto no se toma 
//              en cuenta
//      RBDJ_IndiceProbabilidad         : considere un peso
//              probabilistico, las basuras del dibujo
//              tiene pesos entre 0.3 y 3
//      RBDJ_IndiceScale                : valor Scale para ajustar
//              el objeto
//      RBDJ_IndiceVarScale             : Introduce variabilidad en 
//              Scale( su magnitud se aplica en el objeto original )
//      RBDJ_IndiceTextura              : Indice para buscar el material
//              en RBDJ_ArregloMaterial 
// E. Se recomienda definir un valor Clave para su Articulo
//      por ejemplo ClaveBasuraPesonal = 10000;
//      Esta version tiene 10 objetos, asi que si utiliza valores
//      mayores de 10000 no deberia haber problemas.
// F. Aumente en una unidad RBDJ_TotalArticulos, y RBDJ_TotalMaterial
// F. Si desea sustituir alguna basura, que no
//      es apropiada para la epoca del dibujo, puede valerse
//      del siguiente proceso
//      RBDJ_ObtenerUbicacion(MyDato,RBDJ_A9)
//      RBDJ_DescriptorArticulos[MyDato][RBDJ_IndiceActivo] = off;
//      RBDJ_ObtenerUbicacion(MyDato,ClaveBasuraPersonal)
//      RBDJ_DescriptorArticulos[MyDato][RBDJ_IndiceActivo] = on;
//
// Por ejemplo, el siguiente....
// #declare BasuraPersonal      = sphere { 0, 1 }
// #declare MaterialPersonal    = material {texture {pigment {Red}}}
// #declare RBDJ_ArregloArticulos
//              [ RBDJ_TotalArticulos ] = BasuraPersonal;
// #declare RBDJ_ArregloMaterial
//              [ RBDJ_TotalMaterial ]   = MaterialPersonal;
// #declare ClaveBasuraPersonal = 10000;
// #declare RBDJ_DescriptorArticulos[ RBDJ_TotalArticulos ]
//              [ RBDJ_IndiceIdentificador ]     = ClaveBasuraPersonal;
// #declare RBDJ_DescriptorArticulos[ RBDJ_TotalArticulos ]
//              [ RBDJ_IndiceActivo        ]     = on;
// #declare RBDJ_DescriptorArticulos[ RBDJ_TotalArticulos ]
//              [ RBDJ_IndiceProbabilidad  ]     = 20;
// #declare RBDJ_DescriptorArticulos[ RBDJ_TotalArticulos ]
//              [ RBDJ_IndiceScale         ]     = 0.025;
// #declare RBDJ_DescriptorArticulos[ RBDJ_TotalArticulos ]
//              [ RBDJ_IndiceVarScale      ]     = 0.01;
// #declare RBDJ_DescriptorArticulos[ RBDJ_TotalArticulos ]
//              [ RBDJ_IndiceTextura       ]     = RBDJ_TotalMaterial; 
// #declare ClaveBasuraPersonal         = RBDJ_TotalArticulos;
// #declare RBDJ_TotalArticulos         = RBDJ_TotalArticulos+1; 
// #declare RBDJ_TotalMaterial          = RBDJ_TotalMaterial+1;
//                      
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario
// #declare RBDJ_DefaultTexturaBasurero         = texture { ... }
//      Se aplica al basurero, su valor defualt es
//      RBDJ_TexturaBasurero
// #declare RBDJ_DefaultTexturaFondoBasurero    = texture { ... }
//      Se aplica al fondo del basurero su valor default es
//      RBDJ_TexturaFondoBasurero  
// #declare RBDJ_NoBasura                       = false;
//      Si true el basurero se encuentra vacio.
//
// Para colocarlo simplemente
// #include "RBDJ.inc"
// object { RBDJ_Basurero( 2015 ) }
//
// Otro ejemplo para uso de modificador
// #include "RBDJ.inc"
// #declare RBDJ_DefaultTexturaBasurero         = texture       {
//   average
//   texture_map        {
//     [ 0.5 PinkAlabaster              ] 
//     [ 0.5 RBDJ_TexturaBasurero       ]
//   }
// }
// object { RBDJ_Basurero( 2015 ) } 
//
// Un ejemplo de macro de basura
// #include "RBDJ.inc"  
// object       {
//   RBDJ_CirculoBasura( 2100, 1, <0,0,0>, 0.5, 0.05, 0, 0.2 )
// }
//

#include "RBDJ_Obj.inc" 
#include "textures.inc"
           
#declare RBDJ_L                 = 0.001;

#ifndef ( RBDJ_NoBasura )
  #declare RBDJ_NoBasura        = false;
#end

#declare RBDJ_TexturaBasurero           = 
  texture       { 
    pigment     { 
      gradient y
      pigment_map       {
        [ 0.5 Aquamarine ]
        [ 0.5 Orange     ]
      }
    }
  }
  texture       {
    pigment     {
      mandel 10
      rotate    -90*z
      rotate    10*y
      scale     0.04
      translate 0.15*y
      color_map         {
          [ 0.001 rgbt 1     ]
          [ 0.001 color Orange       ]
          [ 0.1   color Orange       ]
          [ 0.1   color Yellow    ]
          [ 0.9   color Yellow    ]
          [ 0.9   color Orange       ]
      }
    }
  }
  texture       {
    pigment     {
      spotted   
      frequency         3    
      scale     0.2
      pigment_map       {
        [ 0.0 color Gray80                 ] 
        [ 0.4 rgbt  <0.5, 0.2, 0.1, 0.9 >  ]
        [ 0.5 rgbt  1                      ] 
        [ 0.9 rgbt  0.95                   ]
        [ 1.0 rgbt  0.60                   ]
      }
    } 
    normal      {
      bumps     0.05
      scale     0.2
    }
  } 
  
#declare RBDJ_TexturaFondoBasurero      = 
  texture       { 
    Rusty_Iron
  }   
  texture       {
    pigment     {
      color Aquamarine  filter 0.95
    }
  }
  
#ifndef ( RBDJ_DefaultTexturaBasurero )
  #declare RBDJ_DefaultTexturaBasurero  = texture       {
    RBDJ_TexturaBasurero
  }          
#end

#ifndef ( RBDJ_DefaultTexturaFondoBasurero )
  #declare RBDJ_DefaultTexturaFondoBasurero     = texture       {
    RBDJ_TexturaFondoBasurero
  }          
#end      

#declare RBDJ_SuperficieCustom  = 0;
#declare RBDJ_SuperficiePlana   = 1;
#declare RBDJ_SuperficieRBDJ1   = 2;

#macro RBDJ_MacroPlana
                ( AlturaSuperficie, BanderaPertenece, XX, YY, VectorA )
  #local AlturaSuperficie       = 0.0;
  #local BanderaPertenece       = true;
#end

#macro RBDJ_MacroRBDJ1
                ( AlturaSuperficie, BanderaPertenece, XX, YY, VectorA )
  #local Piv                    = 
                <XX,YY,VectorA.z>-<VectorA.x, VectorA.y, VectorA.z >;
  #local AlturaSuperficie       = 
                VectorA.z*exp( -VectorA.filter*vdot( Piv, Piv ) );
  #local BanderaPertenece       = true;
#end

#macro RBDJ_RecipientePrincipal
        ( AlturaBasurero, RadioBasurero, 
          TexturaBasurero, TexturaFondoBasurero )
  #local L                      = RBDJ_L;
  union         {
    #local RBDJ_Sor     = < RadioBasurero, AlturaBasurero >;
    sor         {
      19,
      < 0.75    , -0.10  >*RBDJ_Sor,
      < 0.98    , +0.00  >*RBDJ_Sor,
      < 1       , +0.05  >*RBDJ_Sor,
      < 1.03    , +0.07  >*RBDJ_Sor,
      < 1       , +0.09  >*RBDJ_Sor,
      < 1       , +0.10  >*RBDJ_Sor,
      < 1       , +0.20  >*RBDJ_Sor,
      < 1       , +0.30  >*RBDJ_Sor,
      < 1.03    , +0.325 >*RBDJ_Sor,
      < 1       , +0.35  >*RBDJ_Sor,
      < 1       , +0.40  >*RBDJ_Sor,
      < 1       , +0.70  >*RBDJ_Sor,
      < 1       , +0.80  >*RBDJ_Sor,
      < 1       , +0.90  >*RBDJ_Sor,
      < 1       , +0.91  >*RBDJ_Sor,
      < 1.03    , +0.93  >*RBDJ_Sor,
      < 1       , +0.95  >*RBDJ_Sor,
      < 0.98    , +1.00  >*RBDJ_Sor,
      < 0.75    , +1.10  >*RBDJ_Sor
      open
      texture   {
        TexturaBasurero
      }
    }
    sor         {
      19,
      < 0.75    , -0.10  >*RBDJ_Sor,
      < 0.97    , +0.00  >*RBDJ_Sor,
      < 0.94    , +0.05  >*RBDJ_Sor,
      < 0.94    , +0.07  >*RBDJ_Sor,
      < 0.94    , +0.09  >*RBDJ_Sor,
      < 0.94    , +0.10  >*RBDJ_Sor,
      < 0.94    , +0.20  >*RBDJ_Sor,
      < 0.94    , +0.30  >*RBDJ_Sor,
      < 0.97    , +0.325 >*RBDJ_Sor,
      < 0.94    , +0.35  >*RBDJ_Sor,
      < 0.94    , +0.40  >*RBDJ_Sor,
      < 0.94    , +0.70  >*RBDJ_Sor,
      < 0.94    , +0.80  >*RBDJ_Sor,
      < 0.94    , +0.90  >*RBDJ_Sor,
      < 0.94    , +0.91  >*RBDJ_Sor,
      < 0.97    , +0.93  >*RBDJ_Sor,
      < 0.94    , +0.95  >*RBDJ_Sor,
      < 0.98    , +1.00  >*RBDJ_Sor,
      < 0.75    , +1.10  >*RBDJ_Sor
      open
      texture   {
        TexturaBasurero
      }
    }
    cylinder    {
      0.06*AlturaBasurero*y     ,
      0.07*AlturaBasurero*y     ,
      1.01*RadioBasurero      
    }  
    texture     {
      TexturaFondoBasurero
    }
  }
#end

#macro RBDJ_EvaluarProbabilidadTotal()
  #declare RBDJ_ProbabilidadTotal               = 0;
  #local C                      = 0;
  #while ( C < RBDJ_TotalArticulos )
    #if ( RBDJ_DescriptorArticulos[ C ][ RBDJ_IndiceActivo ] )
      #declare RBDJ_ProbabilidadTotal           = RBDJ_ProbabilidadTotal+
                RBDJ_DescriptorArticulos[ C ][ RBDJ_IndiceProbabilidad ];
    #end
    #local C                    = C+1;
  #end
#end
  
#macro RBDJ_ElegirObjeto( S, NumeroElegido )
  #local Aleatorio              = rand( S )*RBDJ_ProbabilidadTotal;
  #local C                      = 0;
  #local BanderaCiclo           = on;
  #while ( ( C < RBDJ_TotalArticulos ) & ( BanderaCiclo ) )
    #if ( RBDJ_DescriptorArticulos[ C ][ RBDJ_IndiceActivo ] )
      #local Pivote             =
                RBDJ_DescriptorArticulos[ C ][ RBDJ_IndiceProbabilidad ];
      #if ( Aleatorio <= Pivote )
        #local BanderaCiclo     = off;
        #local NumeroElegido    = C;
      #end          
      #declare Aleatorio        = Aleatorio-Pivote;
    #end
    #local C                    = C+1;
  #end
#end 

#macro RBDJ_ObtenerUbicacion ( NumeroElegido, Clave )
  #local C                      = 0;
  #while ( RBDJ_DescriptorArticulos[ C ][ RBDJ_IndiceIdentificador ] 
                != Clave )
    #local C                    = C+1;
  #end 
  #local NumeroElegido          = C;
#end    

#macro RBDJ_ObjetoUbicado ( S, Ubicacion )
  #local NumeroElegido          = 0;
  RBDJ_ElegirObjeto( rand( S ), NumeroElegido )
  object                {
    RBDJ_ArregloArticulos[ NumeroElegido ]
    material            {
      RBDJ_ArregloMaterial
       [ RBDJ_DescriptorArticulos[ NumeroElegido ][ RBDJ_IndiceTextura ] ]
    }
    rotate      < rand( S ), rand( S ), rand( S ) >*360
    scale       
      RBDJ_DescriptorArticulos[ NumeroElegido ][ RBDJ_IndiceScale ]
      +2*( rand( S )-0.5 )
      *RBDJ_DescriptorArticulos[ NumeroElegido ][ RBDJ_IndiceVarScale ]
    translate           Ubicacion
  }
#end   

#macro RBDJ_LineaBasura( S, SelectorMacro, 
                XMin, XMax, DeltaX, YY, PuntoCustom, PuntoS )
  #local AlturaSuperficie       = 0;
  #local BanderaPertenece       = on;
  #local XX                     = XMin;
  #while ( XX <= XMax )
    #switch ( SelectorMacro )
      #case ( RBDJ_SuperficieCustom )
         RBDJ_MacroCustom
                ( AlturaSuperficie, BanderaPertenece, XX, YY, PuntoCustom )
      #break   
      #case ( RBDJ_SuperficiePlana )
         RBDJ_MacroPlana
                ( AlturaSuperficie, BanderaPertenece, XX, YY, 0 )
      #break
      #case ( RBDJ_SuperficieRBDJ1 ) 
         RBDJ_MacroRBDJ1
                ( AlturaSuperficie, BanderaPertenece, XX, YY, 
                        <0.1,0.1,0.2,50.0> )
      #break
    #end
    #if ( BanderaPertenece )
      #local NuevoPuntoS        = 
                < rand( S )-0.5, rand( S )-0.5, rand( S )-0.5 >*PuntoS; 
      object    {
        RBDJ_ObjetoUbicado( rand( S ), < XX, YY, AlturaSuperficie >+NuevoPuntoS )
      }
    #end
    #local XX                    = XX+DeltaX;
  #end
#end 

#macro RBDJ_RectanguloBasura
   ( Semilla, SelectorMacro, XMin, XMax, DeltaX, 
        YMin, YMax, DeltaY, PuntoCustom, PuntoS ) 
  RBDJ_EvaluarProbabilidadTotal() 
  #local S                = seed( Semilla );
  union         { 
    #local YY             = YMin;
    #local PivR           = rand( S );
    #while ( YY <= YMax )      
      RBDJ_LineaBasura( S, SelectorMacro, XMin, 
                XMax, DeltaX, YY, PuntoCustom, PuntoS )      
      #local YY           = YY+DeltaY;
    #end  
  }
#end    

#macro RBDJ_CirculoBasura
  ( Semilla, SelectorMacro, Centro, Radio, Delta, PuntoCustom, PuntoS )
  RBDJ_EvaluarProbabilidadTotal()
  union         {
    #local S                    = seed( Semilla );
    #local YY                   = -Radio;
    #while ( YY <= Radio )    
      #local PivR               = rand( S );
      #local Piv                = sqrt( Radio*Radio-YY*YY );
      RBDJ_LineaBasura( S, SelectorMacro, 
                -Piv, Piv, Delta, YY, PuntoCustom, PuntoS )
      #local YY                 = YY+Delta;
    #end
    translate   Centro
  }
#end

#macro RBDJ_RecipienteBasureroDeJulio
  ( Semilla, AlturaBasurero, RadioBasurero, 
    TexturaBasurero, TexturaFondoBasurero )
  union         {  
    #local S            = seed( Semilla );
    RBDJ_RecipientePrincipal
        ( AlturaBasurero, RadioBasurero, 
          TexturaBasurero, TexturaFondoBasurero )
    #if ( !RBDJ_NoBasura )
      #local Pivote     = 0; 
      RBDJ_ObtenerUbicacion ( Pivote, RBDJ_A9 )
      #local PivoteNegro        =
        RBDJ_DescriptorArticulos[ Pivote ][ RBDJ_IndiceActivo ];
      #declare RBDJ_DescriptorArticulos[ Pivote ][ RBDJ_IndiceActivo ]
                                                = off;
      difference        { 
        union           {
          object          {
            RBDJ_CirculoBasura
                ( rand( S )*10000, RBDJ_SuperficieRBDJ1, <0,0,0>, 
                RadioBasurero, 0.1, 0, 0.03 )
            translate   +0.04*z
          }
          object          {
            RBDJ_CirculoBasura
                ( rand( S )*10000, RBDJ_SuperficieRBDJ1, <0,0,0>, 
                RadioBasurero, 0.05, 0, 0.03 )   
            translate   +0.02*z
          }
          object          {
            RBDJ_CirculoBasura
                ( rand( S )*1000, RBDJ_SuperficieRBDJ1, <0,0,0>, 
                RadioBasurero, 0.025, 0, 0.03 )   
 
          }
        }
        cylinder        {
          -z, z, 0.94*RadioBasurero          
          inverse
        }  
        rotate          +90*x
        translate       +0.5*y
      }
      #declare RBDJ_DescriptorArticulos[ Pivote ][ RBDJ_IndiceActivo ]
                                = PivoteNegro;
    #end
  }
#end

#macro RBDJ_Basurero( Semilla ) 
  #local L                      = RBDJ_L;
  #local AlturaBasurero         = 715*L;
  #local RadioBasurero          = 200*L;
  #object       {
    RBDJ_RecipienteBasureroDeJulio
        ( Semilla, AlturaBasurero, RadioBasurero, 
          RBDJ_DefaultTexturaBasurero,
          RBDJ_DefaultTexturaFondoBasurero )
  }
#end