// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 30 agosto 2011
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// APUD AnteojoPersonalUsoDiario
// El archivo dibuja un anteojo simple
// En su estructura posee algunos defectos,
// sera necesario cuidar el angulo de presentacion.
// #macro APUD_Anteojo( FraccionDerecha, FraccionIzquierda )
//      FraccionDerecha         : Fraccion entre 0.0 (abierto) y
//              1.0 (cerrado) de la pata derecha respecto del dueo.
//              Probablemente requiera valores negativos.
//      FraccionIzquierda       : Fraccion entre 0.0 (abierto) y
//              1.0 (cerrado) de la pata izquierda respecto del dueno.
//              Probablemente requiera valores negativos.
// Las caracteristicas del anteojo son las siguientes.
// El anteojo cerrado esta parcialmente centrado en el origen.
// El vidrio sobresale hacia z-.
// La linea imaginaria que une el soporte de las patas y de los aros,
// se encuentra en el plano XY.  Al abrirse, las patas se
// abren hacia z+.
// Cuando el anteojo esta cerrado :
// Min < -52.5, -26.0, -5.00 >*L
// Max < +52.5, +6.50, +11.0 >*L
// Cuando el anteojo esta abierto :
// Min < -47.5, -26.0, -5.00 >*L
// Max < +47.5, +6.50,  +110 >*L
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare APUD_POV3_1                 = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//      En esta version no tiene ningun efecto.
// #declare APUD_DefaultTexturaAro      = texture { ... }
//      Permite modificar la textura de los aros.
// #declare APUD_DefaultTexturaCuero    = texture { ... }
//      Permite modificar la textura final de las patas del anteojo.
// #declare APUD_DefaultTexturaMetal    = texture { ... }
//      Permite modificar la textura a aplicar en el tornillo de giro.
// #declare APUD_DefaultTexturaPlastico = texture { ... }
//      Permite modificar la textura a aplicar en el soporte de nariz.
// #declare APUD_DefaultTexturaPata     = texture { ... }
//      Permite modificar la textura a aplicar en la pata y
//      soporte central.
//
// Para colocarlo simplemente
// #include "APUD.inc"
// object { APUD_Anteojo( 1.0, 1.0 ) }
//
// Otro ejemplo con modificador
// #include "APUD.inc"
// #declare APUD_DefaultTexturaPata             = texture       {
//   PinkAlabaster
// }
// #declare APUD_DefaultTexturaAro              = texture       {
//   pigment    { Pink }
// }
// object       { APUD_Anteojo( 0.0, 0.0 ) }
//

#include "colors.inc"

#local OjoAbsoluto            = 256;
#local VecesCentroAbsoluto    = 10;     
#local L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -5000 >*L
         Gray80
}
light_source    {
         <-500  , 500   , -5000 >*L
         Gray80
}
background      {
         Gray50
}
#include "APUD.inc"

#local FactorAcercamiento       = 14;

object          {
  APUD_Anteojo( 1.0, 1.0 )
  translate       -( VecesCentroAbsoluto+1 )
         *( FactorAcercamiento-1 )/( FactorAcercamiento )*OjoAbsoluto*L*z
}



