// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 26 setiembre 2011
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// RBDJ RecipienteBasureroDeJulio
// El archivo dibuja un basurero sencillo a base
// de fractales
// Los fractales fueron tomados
// de la biblioteca scene/objects de PovRay3.6.
// Siendo entidades matematicas para demostracion, 
// asumo que no habra problema...
// No indican autor.
// #macro RBDJ_Basurero( Semilla )       
//      Semilla                 : parametro de aleatoriedad
//              la idea es misma semilla, mismo basurero.
// Las dimensiones del basurero son :
// Altura               : 715*L
// RadioBasurero        : 200*L
// En posicion basal descansa en el origen del plano XZ,
// orientado hacia y+.
//
// Otras macros que podrian ser de utilidad.
// #macro RBDJ_ObtenerUbicacion ( NumeroElegido, Clave )
//      NumeroElegido           : Variable de salida
//              da un numero secuencial para accesar un objeto basura
//              Posicion en el arreglo de objetos
//      Clave                   : Valor clave de identificacion
//              de basura. Los valores de entrada en la version
//              actual son RBDJ_A1..RBDJ_A10  
//              Valor del campo RBDJ_IndiceIdentificador
//              en el arreglo de objetos
//              
// #macro RBDJ_CirculoBasura
//        ( Semilla, SelectorMacro, Centro, Radio, Delta, 
//                PuntoCustom, PuntoS )
//      Semilla                 : parametros de aleatoriedad.
//      SelectorMacro           : valor para elegir la macro a utilizar
//              RBDJ_SuperficieCustom (definida por el usuario)
//              RBDJ_SuperficiePlana  (plano de altura 0) 
//              RBDJ_SuperficieRBDJ1  (curva default)
//      Centro                  : Centro como Vector3D del circulo
//              de basuras.  Al final de la macro se aplica
//              translate Centro
//      Radio                   : Radio del circulo de basura
//      Delta                   : Separacion media entre basura y basura
//      PuntoCustom             : Parametro libre a pasar a la
//              macro definida por usuario si se necesita.
//      PuntoS                  : Maxima distancia aleatoria
//              para errar la posicion de la basura.
//
// #macro RBDJ_RectanguloBasura
//      ( Semilla, SelectorMacro, XMin, XMax, DeltaX, 
//              YMin, YMax, DeltaY, PuntoCustom, PuntoS ) 
//      Semilla                 : parametros de aleatoriedad.
//      SelectorMacro           : valor para elegir la macro a utilizar
//              RBDJ_SuperficieCustom (definida por el usuario)
//              RBDJ_SuperficiePlana  (plano de altura 0) 
//              RBDJ_SuperficieRBDJ1  (curva default)   
//      XMin                    : Posicion X minima del rectangulo.
//      XMax                    : Posicion X maxima del rectangulo.
//      DeltaX                  : Separacion X de basura y basura.
//      YMin                    : Posicion Y minima del rectangulo.
//      YMax                    : Posicion Y maxima del rectangulo.
//      DeltaY                  : Separacion Y de basura y basura. 
//      PuntoCustom             : Parametro libre a pasar a la
//              macro definida por usuario si se necesita.
//      PuntoS                  : Maxima distancia aleatoria
//              para errar la posicion de la basura.
// El usuario define RBDJ_MacroCustom externamente, similar a...
// #macro RBDJ_MacroCustom
//                 ( AlturaSuperficie, BanderaPertenece, XX, YY, VectorA )
//   #local AlturaSuperficie       = 0.0;
//   #local BanderaPertenece       = true;
// #end
//              AlturaSuperficie        : altura del punto de basura.
//              BanderaPertenece        : si false no hay basura, si
//                      true si se dibuja
//              XX                      : valor X de entrada
//              YY                      : valor Y de entrada
//              VectorA                 : parametro libre de usuario. 
//                      Se refiere a PuntoCustom en otras macros.
// El usuario puede crear o desactivar sus propias basuras,
// Por ejemplo asumamos que tiene el objeto BasuraPersonal, con material
// MaterialPersonal, puede agregarla a la lista de basuras con
// el siguiente proceso
// A. declare su BasuraPersonal y MaterialPersonal, este 
//      ultimo como material
// B. asigne BasuraPersonal como nuevo elemento del
//      arreglo de objetos RBDJ_ArregloArticulos
//      el nuevo elemento tiene indice RBDJ_TotalArticulos
// C. asigne MaterialPersonal como nuevo material del
//      arreglo de materiales RBDJ_ArregloMaterial
//      el nuevo elemento tiene indice RBDJ_TotalMaterial
// D. actualice todos los campos de RBDJ_DescriptorArticulos
//      con el indice RBDJ_TotalArticulos
//      Es importante declarar todos los campos
//      RBDJ_IndiceIdentificador        : puede obtenerse
//              para un objeto conocido con la macro
//              RBDJ_ObtenerUbicacion 
//      RBDJ_IndiceActivo               : con off el objeto no se toma 
//              en cuenta
//      RBDJ_IndiceProbabilidad         : considere un peso
//              probabilistico, las basuras del dibujo
//              tiene pesos entre 0.3 y 3
//      RBDJ_IndiceScale                : valor Scale para ajustar
//              el objeto
//      RBDJ_IndiceVarScale             : Introduce variabilidad en 
//              Scale( su magnitud se aplica en el objeto original )
//      RBDJ_IndiceTextura              : Indice para buscar el material
//              en RBDJ_ArregloMaterial 
// E. Se recomienda definir un valor Clave para su Articulo
//      por ejemplo ClaveBasuraPesonal = 10000;
//      Esta version tiene 10 objetos, asi que si utiliza valores
//      mayores de 10000 no deberia haber problemas.
// F. Aumente en una unidad RBDJ_TotalArticulos, y RBDJ_TotalMaterial
// F. Si desea sustituir alguna basura, que no
//      es apropiada para la epoca del dibujo, puede valerse
//      del siguiente proceso
//      RBDJ_ObtenerUbicacion(MyDato,RBDJ_A9)
//      RBDJ_DescriptorArticulos[MyDato][RBDJ_IndiceActivo] = off;
//      RBDJ_ObtenerUbicacion(MyDato,ClaveBasuraPersonal)
//      RBDJ_DescriptorArticulos[MyDato][RBDJ_IndiceActivo] = on;
//
// Por ejemplo, el siguiente....
// #declare BasuraPersonal      = sphere { 0, 1 }
// #declare MaterialPersonal    = material {texture {pigment {Red}}}
// #declare RBDJ_ArregloArticulos
//              [ RBDJ_TotalArticulos ] = BasuraPersonal;
// #declare RBDJ_ArregloMaterial
//              [ RBDJ_TotalMaterial ]   = MaterialPersonal;
// #declare ClaveBasuraPersonal = 10000;
// #declare RBDJ_DescriptorArticulos[ RBDJ_TotalArticulos ]
//              [ RBDJ_IndiceIdentificador ]     = ClaveBasuraPersonal;
// #declare RBDJ_DescriptorArticulos[ RBDJ_TotalArticulos ]
//              [ RBDJ_IndiceActivo        ]     = on;
// #declare RBDJ_DescriptorArticulos[ RBDJ_TotalArticulos ]
//              [ RBDJ_IndiceProbabilidad  ]     = 20;
// #declare RBDJ_DescriptorArticulos[ RBDJ_TotalArticulos ]
//              [ RBDJ_IndiceScale         ]     = 0.025;
// #declare RBDJ_DescriptorArticulos[ RBDJ_TotalArticulos ]
//              [ RBDJ_IndiceVarScale      ]     = 0.01;
// #declare RBDJ_DescriptorArticulos[ RBDJ_TotalArticulos ]
//              [ RBDJ_IndiceTextura       ]     = RBDJ_TotalMaterial; 
// #declare ClaveBasuraPersonal         = RBDJ_TotalArticulos;
// #declare RBDJ_TotalArticulos         = RBDJ_TotalArticulos+1; 
// #declare RBDJ_TotalMaterial          = RBDJ_TotalMaterial+1;
//                      
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario
// #declare RBDJ_DefaultTexturaBasurero         = texture { ... }
//      Se aplica al basurero, su valor defualt es
//      RBDJ_TexturaBasurero
// #declare RBDJ_DefaultTexturaFondoBasurero    = texture { ... }
//      Se aplica al fondo del basurero su valor default es
//      RBDJ_TexturaFondoBasurero  
// #declare RBDJ_NoBasura                       = false;
//      Si true el basurero se encuentra vacio.
//
// Para colocarlo simplemente
// #include "RBDJ.inc"
// object { RBDJ_Basurero( 2015 ) }
//
// Otro ejemplo para uso de modificador
// #include "RBDJ.inc"
// #declare RBDJ_DefaultTexturaBasurero         = texture       {
//   average
//   texture_map        {
//     [ 0.5 PinkAlabaster              ] 
//     [ 0.5 RBDJ_TexturaBasurero       ]
//   }
// }
// object { RBDJ_Basurero( 2015 ) } 
//
// Un ejemplo de macro de basura
// #include "RBDJ.inc"  
// object       {
//   RBDJ_CirculoBasura( 2100, 1, <0,0,0>, 0.5, 0.05, 0, 0.2 )
// }
//
             
#include "colors.inc"
#local   OjoAbsoluto            = 256;
#local   VecesCentroAbsoluto    = 10;     
#local   L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
} 
light_source    {
         <-100  , 100   , -3000 >*L
         White
}
background      {
         Gray50
}  
#include "RBDJ.inc"
  
object                  {
  RBDJ_Basurero( 2051 )
  translate     -0.5*y 
  translate     0.2*x
} 
 

object                  { 
  difference            {
    union               { 
  
    RBDJ_CirculoBasura( 2100, 1, <0,0,0>, 0.5, 0.05, 0, 0.2 ) 
      rotate      -90*x
    }
    plane               {
      y,0
    }
  }   
  translate     -.5*y
}

           