// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 26 setiembre 2011
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// RBDJ RecipienteBasureroDeJulio
// El archivo dibuja un basurero sencillo a base
// de fractales
// Los fractales fueron tomados
// de la biblioteca scene/objects de PovRay3.6.
// Siendo entidades matematicas para demostracion, 
// asumo que no habra problema...
// No indican autor.
// #macro RBDJ_Basurero( Semilla )       
//      Semilla                 : parametro de aleatoriedad
//              la idea es misma semilla, mismo basurero.
// Las dimensiones del basurero son :
// Altura               : 715*L
// RadioBasurero        : 200*L
// En posicion basal descansa en el origen del plano XZ,
// orientado hacia y+.
//
// Otras macros que podrian ser de utilidad.
// #macro RBDJ_ObtenerUbicacion ( NumeroElegido, Clave )
//      NumeroElegido           : Variable de salida
//              da un numero secuencial para accesar un objeto basura
//              Posicion en el arreglo de objetos
//      Clave                   : Valor clave de identificacion
//              de basura. Los valores de entrada en la version
//              actual son RBDJ_A1..RBDJ_A10  
//              Valor del campo RBDJ_IndiceIdentificador
//              en el arreglo de objetos
//              
// #macro RBDJ_CirculoBasura
//        ( Semilla, SelectorMacro, Centro, Radio, Delta, 
//                PuntoCustom, PuntoS )
//      Semilla                 : parametros de aleatoriedad.
//      SelectorMacro           : valor para elegir la macro a utilizar
//              RBDJ_SuperficieCustom (definida por el usuario)
//              RBDJ_SuperficiePlana  (plano de altura 0) 
//              RBDJ_SuperficieRBDJ1  (curva default)
//      Centro                  : Centro como Vector3D del circulo
//              de basuras.  Al final de la macro se aplica
//              translate Centro
//      Radio                   : Radio del circulo de basura
//      Delta                   : Separacion media entre basura y basura
//      PuntoCustom             : Parametro libre a pasar a la
//              macro definida por usuario si se necesita.
//      PuntoS                  : Maxima distancia aleatoria
//              para errar la posicion de la basura.
//
// #macro RBDJ_RectanguloBasura
//      ( Semilla, SelectorMacro, XMin, XMax, DeltaX, 
//              YMin, YMax, DeltaY, PuntoCustom, PuntoS ) 
//      Semilla                 : parametros de aleatoriedad.
//      SelectorMacro           : valor para elegir la macro a utilizar
//              RBDJ_SuperficieCustom (definida por el usuario)
//              RBDJ_SuperficiePlana  (plano de altura 0) 
//              RBDJ_SuperficieRBDJ1  (curva default)   
//      XMin                    : Posicion X minima del rectangulo.
//      XMax                    : Posicion X maxima del rectangulo.
//      DeltaX                  : Separacion X de basura y basura.
//      YMin                    : Posicion Y minima del rectangulo.
//      YMax                    : Posicion Y maxima del rectangulo.
//      DeltaY                  : Separacion Y de basura y basura. 
//      PuntoCustom             : Parametro libre a pasar a la
//              macro definida por usuario si se necesita.
//      PuntoS                  : Maxima distancia aleatoria
//              para errar la posicion de la basura.
// El usuario define RBDJ_MacroCustom externamente, similar a...
// #macro RBDJ_MacroCustom
//                 ( AlturaSuperficie, BanderaPertenece, XX, YY, VectorA )
//   #local AlturaSuperficie       = 0.0;
//   #local BanderaPertenece       = true;
// #end
//              AlturaSuperficie        : altura del punto de basura.
//              BanderaPertenece        : si false no hay basura, si
//                      true si se dibuja
//              XX                      : valor X de entrada
//              YY                      : valor Y de entrada
//              VectorA                 : parametro libre de usuario. 
//                      Se refiere a PuntoCustom en otras macros.
// El usuario puede crear o desactivar sus propias basuras,
// Por ejemplo asumamos que tiene el objeto BasuraPersonal, con material
// MaterialPersonal, puede agregarla a la lista de basuras con
// el siguiente proceso
// A. declare su BasuraPersonal y MaterialPersonal, este 
//      ultimo como material
// B. asigne BasuraPersonal como nuevo elemento del
//      arreglo de objetos RBDJ_ArregloArticulos
//      el nuevo elemento tiene indice RBDJ_TotalArticulos
// C. asigne MaterialPersonal como nuevo material del
//      arreglo de materiales RBDJ_ArregloMaterial
//      el nuevo elemento tiene indice RBDJ_TotalMaterial
// D. actualice todos los campos de RBDJ_DescriptorArticulos
//      con el indice RBDJ_TotalArticulos
//      Es importante declarar todos los campos
//      RBDJ_IndiceIdentificador        : puede obtenerse
//              para un objeto conocido con la macro
//              RBDJ_ObtenerUbicacion 
//      RBDJ_IndiceActivo               : con off el objeto no se toma 
//              en cuenta
//      RBDJ_IndiceProbabilidad         : considere un peso
//              probabilistico, las basuras del dibujo
//              tiene pesos entre 0.3 y 3
//      RBDJ_IndiceScale                : valor Scale para ajustar
//              el objeto
//      RBDJ_IndiceVarScale             : Introduce variabilidad en 
//              Scale( su magnitud se aplica en el objeto original )
//      RBDJ_IndiceTextura              : Indice para buscar el material
//              en RBDJ_ArregloMaterial 
// E. Se recomienda definir un valor Clave para su Articulo
//      por ejemplo ClaveBasuraPesonal = 10000;
//      Esta version tiene 10 objetos, asi que si utiliza valores
//      mayores de 10000 no deberia haber problemas.
// F. Aumente en una unidad RBDJ_TotalArticulos, y RBDJ_TotalMaterial
// F. Si desea sustituir alguna basura, que no
//      es apropiada para la epoca del dibujo, puede valerse
//      del siguiente proceso
//      RBDJ_ObtenerUbicacion(MyDato,RBDJ_A9)
//      RBDJ_DescriptorArticulos[MyDato][RBDJ_IndiceActivo] = off;
//      RBDJ_ObtenerUbicacion(MyDato,ClaveBasuraPersonal)
//      RBDJ_DescriptorArticulos[MyDato][RBDJ_IndiceActivo] = on;
//
// Por ejemplo, el siguiente....
// #declare BasuraPersonal      = sphere { 0, 1 }
// #declare MaterialPersonal    = material {texture {pigment {Red}}}
// #declare RBDJ_ArregloArticulos
//              [ RBDJ_TotalArticulos ] = BasuraPersonal;
// #declare RBDJ_ArregloMaterial
//              [ RBDJ_TotalMaterial ]   = MaterialPersonal;
// #declare ClaveBasuraPersonal = 10000;
// #declare RBDJ_DescriptorArticulos[ RBDJ_TotalArticulos ]
//              [ RBDJ_IndiceIdentificador ]     = ClaveBasuraPersonal;
// #declare RBDJ_DescriptorArticulos[ RBDJ_TotalArticulos ]
//              [ RBDJ_IndiceActivo        ]     = on;
// #declare RBDJ_DescriptorArticulos[ RBDJ_TotalArticulos ]
//              [ RBDJ_IndiceProbabilidad  ]     = 20;
// #declare RBDJ_DescriptorArticulos[ RBDJ_TotalArticulos ]
//              [ RBDJ_IndiceScale         ]     = 0.025;
// #declare RBDJ_DescriptorArticulos[ RBDJ_TotalArticulos ]
//              [ RBDJ_IndiceVarScale      ]     = 0.01;
// #declare RBDJ_DescriptorArticulos[ RBDJ_TotalArticulos ]
//              [ RBDJ_IndiceTextura       ]     = RBDJ_TotalMaterial; 
// #declare ClaveBasuraPersonal         = RBDJ_TotalArticulos;
// #declare RBDJ_TotalArticulos         = RBDJ_TotalArticulos+1; 
// #declare RBDJ_TotalMaterial          = RBDJ_TotalMaterial+1;
//                      
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario
// #declare RBDJ_DefaultTexturaBasurero         = texture { ... }
//      Se aplica al basurero, su valor defualt es
//      RBDJ_TexturaBasurero
// #declare RBDJ_DefaultTexturaFondoBasurero    = texture { ... }
//      Se aplica al fondo del basurero su valor default es
//      RBDJ_TexturaFondoBasurero  
// #declare RBDJ_NoBasura                       = false;
//      Si true el basurero se encuentra vacio.
//
// Para colocarlo simplemente
// #include "RBDJ.inc"
// object { RBDJ_Basurero( 2015 ) }
//
// Otro ejemplo para uso de modificador
// #include "RBDJ.inc"
// #declare RBDJ_DefaultTexturaBasurero         = texture       {
//   average
//   texture_map        {
//     [ 0.5 PinkAlabaster              ] 
//     [ 0.5 RBDJ_TexturaBasurero       ]
//   }
// }
// object { RBDJ_Basurero( 2015 ) } 
//
// Un ejemplo de macro de basura
// #include "RBDJ.inc"  
// object       {
//   RBDJ_CirculoBasura( 2100, 1, <0,0,0>, 0.5, 0.05, 0, 0.2 )
// }
//

#include "stones.inc"   
#include "metals.inc"   
#include "textures.inc"                           
                                 
// Los siguientes fractales fueron tomados
// de la biblioteca scene/objects de PovRay3.6.
// Siendo entidades matemticas para demostracin, 
// asumo que no habr problema...
// No indican autor.        
#declare RBDJ_Prec1             = 15;   

#declare RBDJ_Prec2             = 10;
                        
#declare RBDJ_Z2_1              =
julia_fractal {
    <-0.083,0.0,-0.83,-0.025>
    quaternion
    sqr
    max_iteration 8
    precision RBDJ_Prec1
}

#declare RBDJ_Z2_2              =
julia_fractal {
    <-0.03,0.5,-0.2,-0.5>
    quaternion
    sqr
    max_iteration 8
    precision RBDJ_Prec1
}

#declare RBDJ_Z3_1              =
julia_fractal {
    <-0.083,0.0,-0.83,-0.025>
    max_iteration 8
    precision RBDJ_Prec1
    quaternion
    cube
}

#declare RBDJ_Z3_2              =
julia_fractal {
    <-0.03,0.5,-0.2,-0.5>
    max_iteration 8
    precision RBDJ_Prec1
    quaternion
    cube
}

#declare RBDJ_Fractal2_A        =
julia_fractal {
    <0.2, 0.1, 0.59, -0.2>
    max_iteration 7
    precision RBDJ_Prec2
    sqr
    hypercomplex
//    texture {
//        pigment { rgb <0.8, 0.65, 0.85> }
//        finish { phong 0.7 phong_size 100 }
//    }
    scale 0.5
    rotate <-23, 213, -153>
//    translate <1, 0.5, 1>
//  nuevo scale
    scale <0.15,0.04,0.04>

}

#declare RBDJ_Fractal2_B        =
julia_fractal {
    <0.02, -0.02, 0.8, 0>
    max_iteration 10
    precision RBDJ_Prec2
    sqr
    quaternion

    interior {ior 1.5}
//    texture {
//        pigment { rgbf <0.8, 0.3, 0.2, 0.9>  }
//        finish {
//            phong 0.3
//            phong_size 200
//            reflection 0.4
//        }
//    }
    rotate <40, -30, 120>
//    translate <0, 1.12, 0>
    scale 0.5
//    translate <-1, 0.5, 1>
}
   
#declare RBDJ_Fractal2_C        =   
julia_fractal {
    <0.33, 0.54, 0.52, 0.32>
    max_iteration  7
    precision RBDJ_Prec2
    cube
    quaternion

//    interior {ior 1.2}
//    texture {
//        pigment { rgbf <0.8, 0.3, 0.2, 0.9>  }
//        finish {
//            phong 0.3
//            phong_size 200
//            reflection 0.4
//        }
//    }
    scale 0.5
    rotate <-80, 30, -120>
//    translate <1, 0.5, -1>
}

#declare RBDJ_Fractal2_D        =
intersection {
    julia_fractal {
        <-0.54, 0.57, 0.0, -0.37>
        max_iteration 8
        precision RBDJ_Prec2
        cube
//        texture {
//            pigment { rgb <0.5, 0.3, 0.5> }
//            scale 0.7
//            finish { reflection 0.4 }
//        }
    }
    box { <-3, -3, -3>, <3, 3, 0.2> texture { T_Stone11 } }

    rotate <0, 30, 110>
    scale 0.5
//    translate <-1, 0.5, -1>
}

#declare RBDJ_Fractal3          =
julia_fractal {
        <.49,.5,-.34,.1>
        quaternion
        max_iteration 7
        precision 400
//	texture {  pigment { color rgb <.7,.9,.8> }
//		   finish {phong .3 phong_size 200 }
//   }
   rotate <110,50,-60>
}

#declare RBDJ_Fractal4          =
julia_fractal {
        <-.745,0,.113,.05>
        max_iteration 9
        precision 20
        hypercomplex
//	texture {  pigment { color rgb <.9,.5,.6> }
//		   finish { phong .9 phong_size 20 }
//  	}
        rotate <135,-30,0>
}    

// Aqui termina la lista de
// los fractales fueron tomados
// de la biblioteca scene/objects de PovRay3.6.
// con ligeras modificiones, especialmente de textura
#declare RBDJ_MaximoTotalArticulos      = 100; 
#declare RBDJ_TotalArticulos    = 10;

#declare RBDJ_A1                = 10;
#declare RBDJ_A2                = 20;
#declare RBDJ_A3                = 30;
#declare RBDJ_A4                = 40;
#declare RBDJ_A5                = 50;
#declare RBDJ_A6                = 60;
#declare RBDJ_A7                = 70;
#declare RBDJ_A8                = 80;
#declare RBDJ_A9                = 90;
#declare RBDJ_A10               = 100;

#declare RBDJ_ArregloArticulosBas       = array [ RBDJ_TotalArticulos ] 
  { RBDJ_Z2_1,  
    RBDJ_Z2_2,
    RBDJ_Z3_1,
    RBDJ_Z2_2,
    RBDJ_Fractal2_A, 
    RBDJ_Fractal2_B,
    RBDJ_Fractal2_C,
    RBDJ_Fractal2_D,
    RBDJ_Fractal3,
    RBDJ_Fractal4       }     
    
#declare RBDJ_IdentificadorMaterial0    = 0;  
#declare RBDJ_Material0                 = 
  material      {
    texture     { 
      pigment { White } 
      finish  { Shiny }
    }
  } 
  
#declare RBDJ_IdentificadorMaterial1    = 1;
#declare RBDJ_Material1                 =
  material      {
    texture     {    
      pigment   {
        radial
        frequency       200 
        scale           0.05
        rotate          60
        turbulence      0.1
        pigment_map     {
          [ 0.2 color Blue  ]
          [ 0.2 color Quartz ]
        }
        warp    {
          black_hole  <0,0,0>, 0.1
        }
      }
      normal    {
        agate
      }
    }
  }
  
#declare RBDJ_IdentificadorMaterial2    = 2;
#declare RBDJ_Material2                 = 
  material              { 
    texture             {
      pigment           {
        onion
        scale   0.1
        pigment_map     {
          [ 0.0 rgbt <0.8,0.8,0.8, 0.5 > ]
          [ 1.0 rgbt <0.8,1.0,0.8, 0.8 > ]
        }
      } 
    }
    texture             {
      pigment           {
        Peel
        turbulence      0.4
        scale   0.2
      }
      normal    {
        agate
        scale   1.0
      }
    } 
    texture             {
      pigment           { 
        agate
        pigment_map     {
          [ 0.2 color Red ]
          [ 0.2 rgbt 1.0 ]
        }
      }
    }
  }                              
  
#declare RBDJ_IdentificadorMaterial3    = 3;
#declare RBDJ_Material3                 = 
  material              { 
    texture             {
      pigment           {
        onion
        scale   0.1
        pigment_map     {
          [ 0.0 rgbt <0.8,0.8,0.8, 0.5 > ]
          [ 1.0 rgbt <0.8,1.0,0.8, 0.8 > ]
        }  
      }
      normal          {
        average       
        normal_map   {
          [ 0.5 agate scale   0.01   ]
          [ 0.5 gradient x    
                turbulence    0.5
                scale         0.1
                rotate        50     ]
        }
      }      
      finish            {
        phong 0.9 phong_size 60  
        irid    {
          0.5
        } 
      } 
    }
  }
  
#declare RBDJ_IdentificadorMaterial4    = 4;
#declare RBDJ_Material4                 =
  material      {
    texture     { 
      T_Brass_3C
      normal    {  
        gradient x
        rotate  <10,-50,20>
        scale   0.01
        turbulence 0.2
      }
    }
  }      
  
#declare RBDJ_IdentificadorMaterial5    = 5;
#declare RBDJ_Material5                 =
  material      {
    texture     { 
      pigment   {
        X_Gradient   
      }
    }
  }      
  
#declare RBDJ_TexturaPiv1       =
    texture     { 
      pigment   { 
        onion   
        pigment_map     {
          [ 0.0 Yellow transmit 0.5 ]
          [ 0.3 Yellow transmit 0.5 ]
          [ 0.7 Red    ]
          [ 1.0 Red    ] 
        }
      }
      normal    {
        granite
      }         
      finish            {
        phong 0.9 phong_size 60  
        irid    {
          0.7
        } 
      } 
    }
#declare RBDJ_TexturaPiv2       =
    texture     {
      Rusty_Iron
    }
    
#declare RBDJ_IdentificadorMaterial6    = 6;
#declare RBDJ_Material6                 =
  material      {
    texture     { 
      average
      texture_map       {
        [ 0.8 RBDJ_TexturaPiv1 ]
        [ 0.2 RBDJ_TexturaPiv2 ]
      }      
    }
  }      
  
#declare RBDJ_IdentificadorMaterial7    = 7;
#declare RBDJ_Material7                 =
  material      {
    M_Yellow_Glass
  }  

#declare RBDJ_MyTextura1Otro            =
    texture       {
      pigment             {
        crackle
        solid
        translate         5
        scale             0.1
        pigment_map       {
          [ 0.0 Gray40 ]
          [ 1.0 Black  ]
        }
      }
      normal              {
        crackle
        solid
        translate         5
        scale             0.1
      }
    }

#declare RBDJ_MyTextura2Otro   = 
    texture       {
      pigment       {
        Gray30
      }
      normal   {
        radial      
        frequency       60
        rotate  90*x
      }
    }
    
#declare RBDJ_IdentificadorMaterial8    = 8;
#declare RBDJ_Material8                 =
  material      {
  texture       {  
    gradient  z
    ramp_wave 
    scale       2
    translate   -0.5*z
    texture_map       {  
      [ 0.0 RBDJ_MyTextura1Otro   ]
      [ 0.5 RBDJ_MyTextura1Otro   ]
      [ 0.5 RBDJ_MyTextura2Otro   ]
      [ 1.0 RBDJ_MyTextura2Otro   ]
    }
  }
}  
      
#declare RBDJ_IdentificadorMaterial9    = 9;
#declare RBDJ_Material9                 =
  material      {
    texture     {
      DMFWood6
      normal    {
        bumps
        scale   0.1
      }
    }
  }      
  
#declare RBDJ_ModoNormal                = 0;
#declare RBDJ_TexturaDefault            = 1000;

#declare RBDJ_TotalIndices              = 6;
    
#declare RBDJ_IndiceIdentificador       = 0;
#declare RBDJ_IndiceActivo              = 1;
#declare RBDJ_IndiceProbabilidad        = 2;
#declare RBDJ_IndiceScale               = 3;
#declare RBDJ_IndiceVarScale            = 4;
#declare RBDJ_IndiceTextura             = 5;

#declare RBDJ_DescriptorArticulosBas    = 
                        array [ RBDJ_TotalArticulos ][ RBDJ_TotalIndices ]
  {
    { RBDJ_A1 , on, 3.00,
      0.025, 0.00, RBDJ_IdentificadorMaterial1 },
    { RBDJ_A2 , on, 3.00, 
      0.025, 0.00, RBDJ_IdentificadorMaterial1 },
    { RBDJ_A3 , on, 3.00, 
      0.05, 0.00, RBDJ_IdentificadorMaterial2 },
    { RBDJ_A4 , on, 3.00, 
      0.05, 0.00, RBDJ_IdentificadorMaterial3 },
    { RBDJ_A5 , on, 0.30, 
      1.00, 0.00, RBDJ_IdentificadorMaterial4 },
    { RBDJ_A6 , on, 0.10, 
      0.2, 0.00, RBDJ_IdentificadorMaterial5 },
    { RBDJ_A7 , on, 0.10, 
      0.3, 0.00, RBDJ_IdentificadorMaterial6 },
    { RBDJ_A8 , on, 0.10, 
      0.2, 0.00, RBDJ_IdentificadorMaterial7 },
    { RBDJ_A9 , on, 0.05, 
      0.2, 0.00, RBDJ_IdentificadorMaterial8 },
    { RBDJ_A10, on, 0.10,
      0.1, 0.00, RBDJ_IdentificadorMaterial9 }
  }

#declare RBDJ_TotalMaterial             = 10;

#declare RBDJ_ArregloMaterialBas        = array [ RBDJ_TotalMaterial ]
  { RBDJ_Material0, RBDJ_Material1, 
    RBDJ_Material2, RBDJ_Material3, 
    RBDJ_Material4, RBDJ_Material5,
    RBDJ_Material6, RBDJ_Material7,
    RBDJ_Material8, RBDJ_Material9 }
  
#declare RBDJ_ArregloArticulos          = 
            array [ RBDJ_MaximoTotalArticulos ]
#declare RBDJ_DescriptorArticulos       = 
            array [ RBDJ_MaximoTotalArticulos ][ RBDJ_TotalIndices ]
#declare RBDJ_ArregloMaterial           = 
            array [ RBDJ_MaximoTotalArticulos ]    

#local C                = 0;
#while ( C < RBDJ_TotalArticulos )
  #declare RBDJ_ArregloArticulos  [ C ]                 = 
                        RBDJ_ArregloArticulosBas  [ C ]
  #local D              = 0;
    #while ( D < RBDJ_TotalIndices )
      #declare RBDJ_DescriptorArticulos[ C ][ D ]       = 
                        RBDJ_DescriptorArticulosBas[ C ][ D ];
    #local D            = D+1;                    
  #end
  #local C              = C+1;
#end        

#local C                = 0;
#while ( C< RBDJ_TotalMaterial )
  #declare RBDJ_ArregloMaterial[ C ]                    =
                        RBDJ_ArregloMaterialBas[ C ]
  #local C              = C+1;
#end